open Odoc_module
open Odoc_name
open Odoc_value
open Doc_outils

type 'a dump = Dump of string * 'a
let chemin = ref "odoc";;
let mode_verbose = ref false;;

let main =
	let usage ="Usage : "^Sys.argv.(0)^" [option] \nCe logiciel sert a modifier le fichier doc.odoc\n"
	in
	Arg.parse [
	  ("-v",Arg.Unit(fun () -> mode_verbose:=true) ,"Mode verbose" ) ;
	  ("-I",Arg.String(fun s ->  chemin:=s) ,"Chemin de recherche" ) ;

		  ] (fun _ -> ()) usage;

	let descr = open_in_bin ((!chemin)^"/doc.odoc") in
	let Dump(a,(l : Odoc_module.t_module list)) = input_value descr in
	close_in descr;

	let rec parcourt2 ll =
		match ll with
		[]->[]
		|t::q-> let mstruct =
			match t with (*
			    Element_module (a:t_module) (*-> Printf.printf "\t\tmodule\n"*)
			    | Element_module_type (a:t_module_type) (*-> Printf.printf "\t\tmodule_type\n"*)
			    | Element_included_module (a:included_module) (*-> Printf.printf "\t\tincluded\n"*)
			    | Element_class (a:Odoc_class.t_class) (*-> Printf.printf "\t\tclass\n"*)
			    | Element_class_type (a:Odoc_class.t_class_type) (*-> Printf.printf "\t\tclass_type\n"*)
			    | Element_value (a:Odoc_value.t_value) -> Printf.printf "\t\tvalue\n";
			    		Printf.printf "\t\t\t\t%s\n" (transforme_nom(a.val_name))
			    | Element_exception (a:Odoc_exception.t_exception) (*-> Printf.printf "\t\texecatpion\n"*)
			    | Element_type (a:Odoc_type.t_type) (*-> Printf.printf "\t\ttype\n"*)
			    | Element_module_comment (a:Odoc_types.text) (*-> Printf.printf "\t\ttmodulecomment\n"*)
			    		-> t*)
			    | Element_value (a:Odoc_value.t_value) -> 
			    		(*Printf.printf "\t\tvalue\n";
			    	       Printf.printf "\t\t\t\t%s\n"*)  
					Element_value (
							{val_name = transforme_nom(a.val_name) ;
							val_info = a.val_info;
							val_type = a.val_type;
							val_recursive = a.val_recursive;
							val_parameters = a.val_parameters;
							val_code = a.val_code;
							val_loc = a.val_loc;}
						      )
			    |_-> t
			in mstruct::(parcourt2 q)
	in

	
	let rec parcourt ll =
		match ll with
		[]->[]
		|t::q->if(!mode_verbose) then Printf.printf "%s\n" (t.m_name);
			let mkind =
			match (t.m_kind) with
			Module_struct  (a:module_element list) ->
				let b =parcourt2 a in 
				Module_struct b;
		        (*| Module_alias (a:module_alias)  -> Printf.printf "\talia\n"
	  		| Module_functor  ((a:(Odoc_parameter.module_parameter list)), (b:module_kind))  -> Printf.printf "\tfunctor\n"
	    		| Module_apply  ((a:module_kind),(b:module_kind))  -> Printf.printf "\tapply\n"
	      		| Module_with  ((a:module_type_kind),(b:string))  -> Printf.printf "\twith\n"
	        	| Module_constraint ((a:module_kind),(b:module_type_kind))  -> Printf.printf "\tconstraint\n"
		*)	|_ -> t.m_kind
			in
			(
			 {
			   m_name= t.m_name  ;
			   m_type= t.m_type  ;
			   m_info= t.m_info  ;
			   m_is_interface= t.m_is_interface  ; 
			   m_file = t.m_file  ;
			   m_kind = mkind  ;
			   m_loc = t.m_loc  ;
			   m_top_deps= t.m_top_deps  ;
			   }
			)::(parcourt q);
	in
	let liste = parcourt l in
	let dump2 = Dump(a,liste) in
	let descr = open_out_bin ((!chemin)^"/doc.odoc") in
	output_value descr dump2;
	close_out descr;
	(*Printf.printf "Fin\n\n"*);;
