(*=======================================================-*-tuareg-*-======
 *
 * MGS : a general model of systems
 *
 *    Olivier Michel      : michel@lami.univ-evry.fr
 *    Jean-Louis Giavitto : giavitto@lami.univ-evry.fr
 *    Antoine Spicher     : aspicher@lami.univ-evry.fr
 *    Julien Cohen        : jcohen@lami.univ-evry.fr
 *    Mailing-list        : mgs@lami.univ-evry.fr
 *    WWW                 : http://mgs.lami.univ-evry.fr
 *
 * LaMI umr 8042 du CNRS, Genopole (C), Universite d'Evry Val d'Essonne
 *
 *
 * -------------------------------------------------------------------
 * File: $RCSfile: printer_achain.ml,v $
 * Symbolic name : $Name:  $
 * Author: OM, JLG, AS
 * Modified: $Date: 2004-12-14 14:57:08 $
 * Version: $Revision: 1.5 $
 * -------------------------------------------------------------------
 *
 * Status: Cf. AChain/def_achain.ml pour les infos sur les types achain et acell
 *          
 *
 *=========================================================================
 *)


open Global;;
open Printf ;;
open Def_achain ;;
open Printer;;
open Valeur;;


__register_version "$RCSfile: printer_achain.ml,v $" "$Revision: 1.5 $" "$Date: 2004-12-14 14:57:08 $";;


let rec string_of_intlist = function (** une fct qui fait des listes d'uid_splx **)
  | [] -> "" 
  | l -> "/"^(string_of_intlist2 l)

and  string_of_intlist2 = function 
  | [] -> "" 
  | a::[] -> (string_of_int a.uid_acell)^"/"
  | a::l  -> (string_of_int a.uid_acell)^"/"^(string_of_intlist2 l)
;;

let string_of_acell x =
  "/"^(string_of_int x.uid_acell)^
  "/:[dim="^(string_of_int x.dim_acell)^
  "; face="^(string_of_intlist x.faces_acell)^
  "; coface="^(string_of_intlist x.cofaces_acell)^"]"
;;

let _uprbval_'outBuffer_acell (b, x) =
  bprintf b "/%d/:[dim=%d; face=%s; coface=%s]"
    x.uid_acell x.dim_acell
    (string_of_intlist x.faces_acell)
    (string_of_intlist x.cofaces_acell);
  valundef

and _upobval1_'outBuffer_string_string_string_funct_acell (b,pre,inter,post,f,x) =
  bprintf b "/%d/:[dim=%d; face=%s; coface=%s]"
    x.uid_acell x.dim_acell
    (string_of_intlist x.faces_acell)
    (string_of_intlist x.cofaces_acell);
  valundef

and _pfbval_'outBufferF_acell (b, x) =
  Format.fprintf b "/%d/:[dim=%d; face=%s; coface=%s]"
    x.uid_acell x.dim_acell
    (string_of_intlist x.faces_acell)
    (string_of_intlist x.cofaces_acell);
  valundef

and _pobval1_'outBufferF_int_string_string_string_funct_acell (b,t,pre,inter,post,f,x) =
  Format.fprintf b "/%d/:[dim=%d; face=%s; coface=%s]"
    x.uid_acell x.dim_acell
    (string_of_intlist x.faces_acell)
    (string_of_intlist x.cofaces_acell);
  valundef
;;

let rec _uprbval_'outBuffer_achain (b, (ch, t)) =
  begin
    bprintf b "%s:{|" t.name;
    let cpt = ref (Core_achain.size ch) in
      Core_achain.iter 
	(fun splx v -> 
	   decr cpt;
	   bprintf b "%a @ %a%s" 
	     Printer.unformatted_prbvalue2 v 
	     Printer.unformatted_prbvalue2 (VAL_acell splx)
	     (if !cpt = 0 then " " else ", "))	
	ch;
      bprintf b "|}";
      Valeur.mgsundef
  end

and plist_aux pps ppval sep x f = match x with
  | [] -> ()
  | a::[] -> ppval (f a); ()
  | a::l -> (ppval (f a)); (pps sep); plist_aux pps ppval sep l f

and _upobval1_'outBuffer_string_string_string_funct_achain (b,pre,inter,post,f,x) =
  Printf.bprintf b "%s " pre;
  plist_aux (Printf.bprintf b "%s")
            (Printf.bprintf b "%a" uprbvalue2  )
            inter
            (List.map snd (Core_achain.to_list (fst x)))
            f;
  Printf.bprintf b " %s" post;
  valundef

and _pfbval_'outBufferF_achain (b, (ch, t)) = 
  begin
    Format.fprintf b "%s:@[<hv>{| @[<hv>" t.name;
    let cpt = ref (Core_achain.size ch) in
      Core_achain.iter 
	(fun splx v -> 
	   decr cpt;
	   Format.fprintf b "%a @@ %a" 
	     Printer.prbvalue2 v 
	     Printer.prbvalue2 (VAL_acell splx);
	   (if !cpt <> 0 then Format.fprintf b ",@,"))
	ch;
      Format.fprintf b " @]@,|}@]";
      Valeur.mgsundef
  end

and plist_aux2 pps ppval sep x f = match x with
  | [] -> ()
  | a::[] -> ppval (f a); ()
  | a::l -> (ppval (f a)); (pps sep); plist_aux2 pps ppval sep l f 

and _pobval1_'outBufferF_int_string_string_string_funct_achain (b,t,pre,inter,post,f,x) =
  Format.pp_open_box b t;
  Format.fprintf b "%s " pre;
  plist_aux2 (Format.fprintf b "%s@,")
             (Format.fprintf b "%a" pfbvalue2  )
             inter
             (List.map snd (Core_achain.to_list (fst x)))
             f;
  Format.fprintf b " %s@]@," post;
  valundef
;;
