(*=======================================================-*-tuareg-*-======
 *
 * MGS : a general model of systems
 *
 *    Olivier Michel      : michel@lami.univ-evry.fr
 *    Jean-Louis Giavitto : giavitto@lami.univ-evry.fr
 *    Antoine Spicher     : aspicher@lami.univ-evry.fr
 *    Julien Cohen        : jcohen@lami.univ-evry.fr
 *    Mailing-list        : mgs@lami.univ-evry.fr
 *    WWW                 : http://mgs.lami.univ-evry.fr
 *
 * LaMI umr 8042 du CNRS, Genopole (C), Universite d'Evry Val d'Essonne
 *
 *
 * -------------------------------------------------------------------
 * File: $RCSfile: type_achain.ml,v $
 * Symbolic name : $Name:  $
 * Author: OM, JLG
 * Modified: $Date: 2005-11-23 11:10:57 $
 * Version: $Revision: 1.3 $
 * -------------------------------------------------------------------
 *
 * Voir les fichier Common/type.ml et AChain/def_achain.ml
 * 
 *=========================================================================
 *)


open Global;;
open Valeur;;
open Type;;
open Type_scalar;;

__register_version "$RCSfile: type_achain.ml,v $" "$Revision: 1.3 $" "$Date: 2005-11-23 11:10:57 $";;


(*!*)(** 
  @module scalar
  @name 'acell
  @type any_bool
  Returns [true] if the argument is a acell and [false] for any other value. 

  [acell] is also the type of the abstract topological cells.
*)(*!*)
let acell_desc = create_type
	        { name = "'acell";
		  concrete = true;
		  leibniz = false;
		  predicate = wrap_pred(is_acell);
		  empty = VAL_undef "dummy for default value field in type descriptor 'acell"; 
		  pospredicate = scalar_desc.pospredicate;
		  make = scalar_desc.make;
		  xxxify = VAL_undef "Type_scalar: undef_desc: not yet implemented on acell";
		  derive_from = [scalar_desc];
		  father_of = [];
		  uid = get_new_uid();
		}
;;

(*!*)(** 
       @module collections
       @name 'achain
       @type any_bool
       Achain type and predicate.
*)(*!*)


let achain_desc = create_type
		    { name = "'achain";
		      concrete = true;
		      leibniz = true;
		      predicate = wrap_pred(is_leibniz);
		      empty = VAL_undef "dummy for empty field in type descriptor 'achain";
		      pospredicate = pospredicate_acell;
		      make = make_dummy;
		      xxxify = xxxify_dummy "'achain";
		      derive_from = [leibniz_desc];
		      father_of = [];
		      uid = get_new_uid();
		    }
;;

achain_desc.predicate <- wrap_pred(coll_pred achain_desc);;
