(*=======================================================-*-tuareg-*-======
 *
 * MGS : a general model of systems
 *
 *    Olivier Michel      : michel@lami.univ-evry.fr
 *    Jean-Louis Giavitto : giavitto@lami.univ-evry.fr
 *    Antoine Spicher     : aspicher@lami.univ-evry.fr
 *    Julien Cohen        : jcohen@lami.univ-evry.fr
 *    Mailing-list        : mgs@lami.univ-evry.fr
 *    WWW                 : http://mgs.lami.univ-evry.fr
 *
 * LaMI umr 8042 du CNRS, Genopole (C), Universite d'Evry Val d'Essonne
 *
 *
 * -------------------------------------------------------------------
 * File: $RCSfile: kernel_gab.ml,v $
 * Symbolic name : $Name:  $
 * Author: OM, JLG
 * Modified: $Date: 2006-04-23 05:22:18 $
 * Version: $Revision: 1.1 $
 * -------------------------------------------------------------------
 *
 * Status: 
 *   voir aussi Common/kernel_collection.ml
 *   qui contient les fcts gnriques sur les collections et les monoidaux.
 *
 *=========================================================================
 *)

open Global;;
open Valeur;;
open Type;;
open Dispatch_sig;;
open Dispatch;;
open Environnement;;
open Gab;;


__register_version "$RCSfile: kernel_gab.ml,v $" "$Revision: 1.1 $" "$Date: 2006-04-23 05:22:18 $";;


print_string "(* loading kernel functions on GAB into user-space ... ";
flush Pervasives.stdout;;



(**
  @module collections
  @name 'gabify
  @type collection_gab
  @type scalar_gab

  Transform its argument into a gab.
  ['gabify(c)] collects allthe elements of the collection
  [c] into a gab. If [c] is already a gab, [gabify] is the identity.
  
  ['gabify(s)] where [s] is a scalar returns
  the gab with [s] as the unique element.
*)
addenv_impure "'gabify"  (fun_1 __gabify );;



(* --- fin de l'installation des fonctions de base --- *)

print_string "done *)";
print_newline();;

(* ======================================================= *)
