(*=======================================================-*-tuareg-*-======
 *
 * MGS : a general model of systems
 *
 *    Olivier Michel      : michel@lami.univ-evry.fr
 *    Jean-Louis Giavitto : giavitto@lami.univ-evry.fr
 *    Antoine Spicher     : aspicher@lami.univ-evry.fr
 *    Julien Cohen        : jcohen@lami.univ-evry.fr
 *    Mailing-list        : mgs@lami.univ-evry.fr
 *    WWW                 : http://mgs.lami.univ-evry.fr
 *
 * LaMI umr 8042 du CNRS, Genopole (C), Universite d'Evry Val d'Essonne
 *
 *
 * -------------------------------------------------------------------
 * File: $RCSfile: type_gab.ml,v $
 * Symbolic name : $Name:  $
 * Author: OM, JLG
 * Modified: $Date: 2006-04-23 05:22:18 $
 * Version: $Revision: 1.1 $
 * -------------------------------------------------------------------
 *
 * Voir le fichier Common/type.ml
 * 
 *=========================================================================
 *)



open Global;;
open Valeur;;
open Type;;

__register_version "$RCSfile: type_gab.ml,v $" "$Revision: 1.1 $" "$Date: 2006-04-23 05:22:18 $";;





(*!*)(** 
       @module collections
       @name 'gab
       @type any_bool
       Gab type and predicate. A gab is a bag where
       negative occurence of an element are allowed.
       @voir 'set      'set
       @voir 'bag      'seq
       @voir 'gab      'gab
       @voir 'monoidal 'monoidal
*)(*!*)

let gab_desc = create_type
		 { name = "'gab";
		   concrete = true;
		   leibniz = false;
		   predicate = wrap_pred(is_leibniz);
		   pospredicate = VAL_funct(fun _ -> VAL_bool true);
		   make = make_dummy;
		   xxxify = xxxify_dummy "'gab";
		   empty = VAL_undef "dummy for empty field in type descriptor 'gab";
		   derive_from = [monoidal_desc];
		   father_of = [];
		   uid = get_new_uid();
		 }
;;

gab_desc.predicate <- wrap_pred(coll_pred gab_desc);;


(** !!! Attention !!!
 *** Ne pas oublier de mettre  jour les champs
 ***     _ make 
 ***     _ xxxify
 ***     _ empty
 *** du descripteur de type dans le fichier bag.ml
 ***)
