(*=======================================================-*-tuareg-*-======
 *
 * MGS : a general model of systems
 *
 *    Olivier Michel      : michel@lami.univ-evry.fr
 *    Jean-Louis Giavitto : giavitto@lami.univ-evry.fr
 *    Antoine Spicher     : aspicher@lami.univ-evry.fr
 *    Julien Cohen        : jcohen@lami.univ-evry.fr
 *    Mailing-list        : mgs@lami.univ-evry.fr
 *    WWW                 : http://mgs.lami.univ-evry.fr
 *
 * LaMI umr 8042 du CNRS, Genopole (C), Universite d'Evry Val d'Essonne
 *
 *
 * -------------------------------------------------------------------
 * File: $RCSfile: def_del.ml,v $
 * Symbolic name : $Name:  $
 * Author: OM, JLG
 * Modified: $Date: 2005-03-07 17:24:52 $
 * Version: $Revision: 1.1 $
 * -------------------------------------------------------------------
 *
 * Status:  
 *     La representation d'un Delaunay.
 *
 *=========================================================================
 *)

Global.__register_version "$RCSfile: def_del.ml,v $" "$Revision: 1.1 $" "$Date: 2005-03-07 17:24:52 $";;

(* **************************** *)
(* Pour les graphes de Delaunay *)
(* **************************** *)

type sommets_voisins    = int list

and has_voronoi     = bool                                         (* Doit-on maintenir des informations relatives aux cellules de Voronoi ? *)
and vor_point       = float
and vor_neighbor    = int
and vor_element     = vor_point * vor_point * (vor_neighbor list)  (* Coordonnees du sommet (en 2D uniquement) et la liste des sommets adjacents du Delaunay    *)
and voronoi         = vor_element array
and vor_open_cell   = bool array

and del_dimension      = int                                               (* Dimension du graphe de Delaunay                                                            *)
and del_position       = float array                                       (* La position en dimension n d'un sommet du graphe (resultat d'un calcul)                    *)
and 'a del_fonction    = ('a -> 'a)                                        (* La fonction utilisee pour le calcul de la position d'un sommet                             *)
and 'a del_def         = del_dimension * ('a del_fonction) * has_voronoi   (* Ce qui caracterise un Graphe de Delaunay :dimension, fonct de calcul, infos sur le Voronoi *)
and 'a del_tab_element = ('a * del_position * sommets_voisins)
and 'a tdel            = ('a del_tab_element Def_graph_generique.graphe_element) * (voronoi * vor_open_cell)
;;
