(*=======================================================-*-tuareg-*-======
 *
 * MGS : a general model of systems
 *
 *    Olivier Michel      : michel@lami.univ-evry.fr
 *    Jean-Louis Giavitto : giavitto@lami.univ-evry.fr
 *    Antoine Spicher     : aspicher@lami.univ-evry.fr
 *    Julien Cohen        : jcohen@lami.univ-evry.fr
 *    Mailing-list        : mgs@lami.univ-evry.fr
 *    WWW                 : http://mgs.lami.univ-evry.fr
 *
 * LaMI umr 8042 du CNRS, Genopole (C), Universite d'Evry Val d'Essonne
 *
 *
 * -------------------------------------------------------------------
 * File: $RCSfile: printer_del.ml,v $
 * Symbolic name : $Name:  $
 * Author: OM, JLG
 * Modified: $Date: 2005-09-21 15:36:07 $
 * Version: $Revision: 1.2 $
 * -------------------------------------------------------------------
 *
 * Status:  
 *    Implantation au niveau "representation MGS" des fonctions sur les 
 *    sequences.
 *
 *    Dans un rpertoire Xxx correspondant  une collection xxx, 
 *    le type xxx est defini dans def_xxx.ml et les operations sur 
 *    ce type sont dfinies dans core_xxx.ml. Le fichier kernel_xxx.ml
 *    contient la declaration dans la librairie MGS des fcts dfinies 
 *    dans xxx.ml
 *
 *    L'organisation de xxx.ml fichier suit l'ordre suivant:
 *
 *       1/ Fonctions de construction: ... -> seq (sauf extension)
 *             cons, join, append, shape, xxxify, iota, extension
 *
 *       2/ Prdicats, accs et observateur
 *             compare, val2bool, size, empty, count, 
 *             member, random, hd, tl, take
 *
 *       3/ Fold et autre itrations
 *             fold, map, iter, foldindexed, mapindexed, iterindexed,
 *             forall, exists, filter
 *
 *       4/ Neighbors, neighbor
 *
 *
 *       5/ Fonctions spcifiques
 *
 *
 *       6/ mise  jour du descripteur du type
 *              champs: make, xxxify et empty
 *
 * Ici :   xxx = gbf
 *
 *=========================================================================
 *)

open Global;;
open Auxfct;;
open Dispatch_sig;;
open Printf ;;
open Def_del;;
open Core_del;;
open Printer;;
open Valeur;;


let _uprbval_'outBuffer_del (b, ((tab, _), deco)) =
  (Printer_graph_generique.print
      b 
      (fun (deco, pos) ->
	 (
	   unformatted_prbvalue2 b deco; 
	   Printf.bprintf b "@ [%s]"
	     (
	       Global.clean_comma_string_of_general_array string_of_float pos
	     )
	 )
      )
      decopos
      vois
      tab
      deco.name;
    mgsundef
  )

 and _pfbval_'outBufferF_del (b, ((tab, _), deco)) =
  (
    Printer_graph_generique.print2
     b 
     (fun (deco, pos) -> (prbvalue2 b deco; 
			  Format.fprintf b "@ [%s]"    (Global.clean_comma_string_of_general_array string_of_float pos))
     )
     decopos
     vois
     tab
     deco.name;
    mgsundef
  )

(*
and _pzbval_'outBufferF_int_string_string_string_funct_seq_del (b,t,pre,inter,post,f,l,x) =
  Format.pp_open_box b t;
  Format.fprintf b "%s" pre;
  Auxfct.plist_aux2 
    (Format.fprintf b "%s@,")
    (Format.fprintf b "%a" (fun b x->(fprintcollrecpar b x (VAL_seq l);()))  )
    inter
    (Array.to_list (fst (fst x) ))
    (*(Hash.fold (fun k v suite -> v::suite) (fst x) [])*)
    (fun x -> f (deco x));
  Format.fprintf b " %s@]@," post;
  Valeur.mgsundef
*)

and _pobval1_'outBufferF_int_string_string_string_funct_del (b,t,pre,inter,post,f,x) =
  Format.pp_open_box b t;
  Format.fprintf b "%s" pre;
  Auxfct.plist_aux2 
    (Format.fprintf b "%s@,") 
    (Format.fprintf b "%a" prbvalue2)
    inter 
    (Array.to_list ((fst (fst x))) ) (fun x -> f (deco x));
  Format.fprintf b " %s@]@," post;
  Valeur.mgsundef
;;
