(*=======================================================-*-tuareg-*-======
 *
 * MGS : a general model of systems
 *
 *    Olivier Michel      : michel@lami.univ-evry.fr
 *    Jean-Louis Giavitto : giavitto@lami.univ-evry.fr
 *    Antoine Spicher     : aspicher@lami.univ-evry.fr
 *    Julien Cohen        : jcohen@lami.univ-evry.fr
 *    Mailing-list        : mgs@lami.univ-evry.fr
 *    WWW                 : http://mgs.lami.univ-evry.fr
 *
 * LaMI umr 8042 du CNRS, Genopole (C), Universite d'Evry Val d'Essonne
 *
 *
 * -------------------------------------------------------------------
 * File: $RCSfile: printer_graph_generique.ml,v $
 * Symbolic name : $Name:  $
 * Author: OM, JLG, AS
 * Modified: $Date: 2005-03-07 17:24:52 $
 * Version: $Revision: 1.1 $
 * -------------------------------------------------------------------
 *
 *
 *=========================================================================
 *)

open Global;;
open Auxfct;;
open Dispatch_sig;;
open Printf ;;
open Def_graph_generique ;;
open Core_graph_generique ;;
open Printer;;
open Valeur;;


let formatted_print b fonc_print_sommet fonc_extrait_deco fonc_extrait_voisins tab couleur = 
  if (0 <> Array.length tab)
  then (Format.fprintf b "[";
	for i = 0 to (Array.length tab)-1
	do
	  let deco_sommet   = fonc_extrait_deco tab.(i)
	  and liste_voisins = fonc_extrait_voisins tab.(i)
	  in
	    Format.fprintf b "\t%d := " i;
	    fonc_print_sommet deco_sommet;
	    Format.fprintf b " :> %s\n" (Global.clean_comma_string_of_general_list string_of_int liste_voisins)
	done;
	Format.fprintf b "\n]")
  else Format.fprintf b "[ ]";
  Format.fprintf b " : %s\n" couleur

and print b fonc_print_sommet fonc_extrait_deco fonc_extrait_voisins tab couleur = 
  if (0 <> Array.length tab)
  then (Printf.bprintf b "[";
	for i = 0 to (Array.length tab)-1
	do
	  let deco_sommet   = fonc_extrait_deco tab.(i)
	  and liste_voisins = fonc_extrait_voisins tab.(i)
	  in
	    Printf.bprintf b "\t%d := " i;
	    fonc_print_sommet deco_sommet;
	    Printf.bprintf b " :> %s\n" (Global.clean_comma_string_of_general_list string_of_int liste_voisins)
	done;
	Printf.bprintf b "\n]")
  else Printf.bprintf b "[ ]";
  Printf.bprintf b " : %s\n" couleur


(** --- Affichage formatt ------------------------------------------------------- **)

(** print2 b fonc_print_sommet fonc_extrait_deco fonc_extrait_voisins tab couleur :
 **  mme chose que print sauf que b est buffer format 
 **)
let print2 b fonc_print_sommet fonc_extrait_deco fonc_extrait_voisins tab couleur =
  Format.fprintf b "@[<b 1>";
  if (0 = Array.length tab) 
  then Format.fprintf b "[ ]"
  else
    begin
      Format.fprintf b "[";
      for i = 0 to (Array.length tab)-1 do
        let deco_sommet   = fonc_extrait_deco tab.(i)
        and liste_voisins = fonc_extrait_voisins tab.(i)
        in
          Format.fprintf b "@[<b 1>%d := " i;
          fonc_print_sommet deco_sommet;
          Format.fprintf b " :> %s@]@, " (Global.clean_comma_string_of_general_list string_of_int liste_voisins)
      done;
      Format.fprintf b "]"
    end;
  Format.fprintf b " : %s@]@," couleur
;;
