/*
 *
 *                              MGS
 *                              LaMI
 *                       Universite d'Evry Val d'Essonne
 *                   Olivier MICHEL, Jean-Louis GIAVITTO
 * File: $RCSfile: stub_nauty.c,v $ 
 * Path: %P%
 * Description:
 * Created:
 * Author: Olivier Michel & Jean-Louis Giavitto
 * Modified: $Date: 2005-03-07 17:24:52 $ at 
 * Version: $Revision: 1.1 $
 * Status:
 *
 */

#include <mlvalues.h>       /* for OCAML */
#include <memory.h>
#include "nauty.h"          /* which includes <stdio.h> */
#include <assert.h>
#include <string.h>


value nauty_stub_usage()
{
  CAMLparam0();
  fprintf(stderr, "(* registering nauty functions (http://cs.anu.edu.au/~bdm/nauty/) *)\n");
  fflush(stderr);
  CAMLreturn(Val_unit);
}

value nauty_compare(value int_size, value intlist_array_g1, value intlist_array_g2)
 { 
   CAMLparam3(int_size, intlist_array_g1, intlist_array_g2);
   CAMLlocal3(base, ptr, ret); 

   DYNALLSTAT(graph,g,g_sz);
   DYNALLSTAT(graph,canon,canon_sz);
   DYNALLSTAT(graph,canon1,canon_sz1);
   DYNALLSTAT(int,lab,lab_sz);
   DYNALLSTAT(int,ptn,ptn_sz);
   DYNALLSTAT(int,orbits,orbits_sz);
   static DEFAULTOPTIONS(options); 
   statsblk(stats); 
   setword *workspace;           /* >= 50m */
   int n,m,v;
   set *gv, *gv1;
   int i, j, equal;
   
   int compteur = 0, base_idx;

   options.defaultptn   = TRUE;  /* Ignore lab et ptn */
   options.writeautoms  = TRUE;
   options.writemarkers = TRUE;
   options.getcanon     = TRUE;  /* On calcule le graphe canonique */
   options.digraph      = TRUE;  /* Ce sont des graphes diriges    */

   options.writeautoms  = FALSE; /* On ne veut pas de sortie sur stdout */
   options.writemarkers = FALSE;

   n = Int_val(int_size);
   m = (n + WORDSIZE - 1) / WORDSIZE;
   workspace=(setword *)calloc(75 * m, sizeof(setword));

   nauty_check(WORDSIZE,m,n,NAUTYVERSIONID);
   DYNALLOC2(graph,g,g_sz,m,n,"malloc");
   DYNALLOC2(graph,canon,canon_sz,m,n,"malloc");
   DYNALLOC2(graph,canon1,canon_sz1,m,n,"malloc");
   DYNALLOC1(int,lab,lab_sz,n,"malloc");
   DYNALLOC1(int,ptn,ptn_sz,n,"malloc");
   DYNALLOC1(int,orbits,orbits_sz,n,"malloc");


  for(base = intlist_array_g1, base_idx = 0; base_idx < Wosize_val(base); base_idx ++)   /* On itere sur chaque sommet  */
    {
      gv = GRAPHROW(g, base_idx, m);
      EMPTYSET(gv,m);

      for(ptr = Field(base, base_idx); ptr != Val_int(0); ptr = Field(ptr, 1))           /* On itere sur chaque voisin  */
	ADDELEMENT(gv, Int_val(Field(ptr, 0)));
    }

  /* putgraph(stdout,g,options.linelength,m,n); */

   nauty(g,lab,ptn,NULL,orbits,&options,&stats, workspace, (75*m),m,n,canon);

   /*  putgraph(stdout,canon,options.linelength,m,n); /* Sortie pour visualiser le graphe canonique */ 


  for(base = intlist_array_g2, base_idx = 0; base_idx < Wosize_val(base); base_idx ++)   /* On itere sur chaque sommet  */
    {
      gv = GRAPHROW(g, base_idx, m);
      EMPTYSET(gv,m);

      for(ptr = Field(base, base_idx); ptr != Val_int(0); ptr = Field(ptr, 1))           /* On itere sur chaque voisin  */
	ADDELEMENT(gv, Int_val(Field(ptr, 0)));
    }

  /* putgraph(stdout,g,options.linelength,m,n); */

   nauty(g,lab,ptn,NULL,orbits,&options,&stats, workspace, (75*m),m,n,canon1);

   /*   putgraph(stdout,canon1,options.linelength,m,n); /* Sortie pour visualiser le graphe canonique */ 
   /*   putgraph(stdout,canon,options.linelength,m,n); /* Sortie pour visualiser le graphe canonique */ 


   //   for (i=0; i < n; i++)
   //     {
   //       gv  = GRAPHROW(canon, i, m);
   //       gv1 = GRAPHROW(canon1, i, m);
   //       
   //       for (j=0; j < n; j++)
   //	 {
   //	   if (ISELEMENT(gv, j) == TRUE)
   //	     if (ISELEMENT(gv1, j) != TRUE)
   //	       {
   //		 equal = FALSE;
   //		 /* printf("Pour le sommet %d, les deux graphes N'ONT PAS tout deux le voisin %d\n", i, j); */
   //		 break;
   //	       }
   //	   /* else printf("Pour le sommet %d, les deux graphes ont le voisin %d\n", i, j); */
   //	 }
   //       if (equal == FALSE) break;
   //     }


   for (i=0, equal = 0; (i < m) && (equal == 0); i++)
     equal = (*(canon+i) == *(canon1+i) ? 0 : (*(canon+i) > *(canon1+i) ? 1 : -1 ));


   free(workspace);

   DYNFREE(g, g_sz);
   DYNFREE(canon, canon_sz);
   DYNFREE(canon1, canon_sz1);
   DYNFREE(lab, lab_sz);
   DYNFREE(ptn, ptn_sz);
   DYNFREE(orbits, orbits_sz);

   CAMLreturn(Val_int(equal));
 }
 
