(*=======================================================-*-tuareg-*-======
 *
 * MGS : a general model of systems
 *
 *    Olivier Michel      : michel@lami.univ-evry.fr
 *    Jean-Louis Giavitto : giavitto@lami.univ-evry.fr
 *    Antoine Spicher     : aspicher@lami.univ-evry.fr
 *    Julien Cohen        : jcohen@lami.univ-evry.fr
 *    Mailing-list        : mgs@lami.univ-evry.fr
 *    WWW                 : http://mgs.lami.univ-evry.fr
 *
 * LaMI umr 8042 du CNRS, Genopole (C), Universite d'Evry Val d'Essonne
 *
 *
 * -------------------------------------------------------------------
 * File: $RCSfile: kernel_graph.ml,v $
 * Symbolic name : $Name:  $
 * Author: OM, JLG, AS
 * Modified: $Date: 2005-07-12 14:23:11 $
 * Version: $Revision: 1.2 $
 * -------------------------------------------------------------------
 *
 * Status: 
 *          
 *
 *=========================================================================
 *)

open Global;;
open Valeur;;
open Environnement;;
open Dispatch;;

__register_version "$RCSfile: kernel_graph.ml,v $" "$Revision: 1.2 $" "$Date: 2005-07-12 14:23:11 $";;

Printf.printf "(* loading kernel functions on GRAPHS into user-space ... ";
flush Pervasives.stdout;;

(*!*)

(***
  @module graph
  The graph topological collection

*)

(**
  @module collections
  @name 'graphify
  @type collection_delaunay
  @type collection_grf

  Transform a delaunay-type graph into a graph.
  It is the identity function on regular graphs.
*)
addenv_impure "'graphify"  (fun_1 __graphify );;

(**
  @name 'isomorphism
  @type grf_grf_bool
  @type del_del_bool

  Test the isomorphism of two graphs.
  Computes if two graph collections are isomorphic (the carrier graphs
  must be isomorphic and two identified vertices must be labeled with
  the same values).
*)
addenv_impure "'isomorphism" (fun_2 __isomorphism);;

(* ============================================================ *)

(* --- fin de l'installation des fonctions --- *)

Printf.printf "done *)\n";

(* ======================================================= *)
