(*=======================================================-*-tuareg-*-======
 *
 * MGS : a general model of systems
 *
 *    Olivier Michel      : michel@lami.univ-evry.fr
 *    Jean-Louis Giavitto : giavitto@lami.univ-evry.fr
 *    Antoine Spicher     : aspicher@lami.univ-evry.fr
 *    Julien Cohen        : jcohen@lami.univ-evry.fr
 *    Mailing-list        : mgs@lami.univ-evry.fr
 *    WWW                 : http://mgs.lami.univ-evry.fr
 *
 * LaMI umr 8042 du CNRS, Genopole (C), Universite d'Evry Val d'Essonne
 *
 *
 * -------------------------------------------------------------------
 * File: $RCSfile: type_graph.ml,v $
 * Symbolic name : $Name:  $
 * Author: OM, JLG
 * Modified: $Date: 2005-03-07 17:24:53 $
 * Version: $Revision: 1.1 $
 * -------------------------------------------------------------------
 *
 * Voir le fichier Common/type.ml
 * 
 *=========================================================================
 *)

open Global;;
open Valeur;;
open Type;;
open Dispatch_sig;;

__register_version "$RCSfile: type_graph.ml,v $" "$Revision: 1.1 $" "$Date: 2005-03-07 17:24:53 $";;


(*!*)(** 
       @module collections
       @name 'graph
       @type any_bool
       Graph type and predicate.
       
       This collection type corresponds to graph where the values are
       carried only by the vertices.

       @voir Graph the chapter graph in the documentation.
*)(*!*)

let graph_desc = create_type
		   { name = "'graph";
		     concrete = true;
		     leibniz = false;
		     predicate = wrap_pred(is_newton);
		     empty = VAL_undef "dummy for empty field in type descriptor 'graph";
		     pospredicate = pospredicate_int;
		     make = make_dummy;
		     xxxify = VAL_funct(graphify);
		     derive_from = [newton_desc];
		     father_of = [];
		     uid = get_new_uid();
		   }
;;

graph_desc.predicate <- wrap_pred(coll_pred graph_desc);;
graph_desc.empty <- VAL_grf(((Hash.create 0), 
			     (Array.make 0 ((VAL_undef "empty grf"),
					    []))),
			    graph_desc);;

let extension_graph nom desc x      = raise (Erreur "extension_graph not yet implemented")
;;
