/*
 *
 *                              MGS
 *                              LaMI
 *                       Universite d'Evry Val d'Essonne
 *                   Olivier MICHEL, Jean-Louis GIAVITTO
 * File: $RCSfile: stub_gmap_ml.h,v $ 
 * Path: %P%
 * Description:
 * Created:
 * Author: Olivier Michel & Jean-Louis Giavitto & Julien Cohen & Antoine Spicher
 * Modified: $Date: 2005-09-07 18:37:43 $ at 
 * Version: $Revision: 1.6 $
 * Status:
 *
 */

#define True  (0==0)
#define False (0==1)

typedef CDart ;
typedef CCoverage ;
typedef SGMapVertex ;

int debugAff = 0 ;

extern CDart* normalForm(SGMapVertex*,CDart*,int);
extern void   qmfy(SGMapVertex*);
extern void   normAll(SGMapVertex*);

extern SGMapVertex* createGmap();
extern int          isFrozen(SGMapVertex*);
extern void         deleteGmap(SGMapVertex*);
extern void         deleteDartsTable(CDart**);
extern SGMapVertex* copyGmap(SGMapVertex*);
extern int          copy_notmarked_dart(SGMapVertex*,SGMapVertex*,int);

extern CDart* copyDart(SGMapVertex*,CDart*);
extern CDart* newDart(SGMapVertex*,float,float,float);
extern CDart* alpha(SGMapVertex*,CDart*,int);
extern void   sew(SGMapVertex*,CDart*,CDart*,int);
extern int    isFree(SGMapVertex*,CDart*,int);
extern int    getNewMark(SGMapVertex*);
extern void   freeMark(SGMapVertex*,int);
extern void   markDart(SGMapVertex*,CDart*,int);
extern void   markNcell(SGMapVertex*,CDart*,int,int);
extern void   unmarkDart(SGMapVertex*,CDart*,int);
extern void   unmarkNcell(SGMapVertex*,CDart*,int,int);
extern int    isMarkedDart(SGMapVertex*,CDart*,int);
extern int    isMarkedNcell(SGMapVertex*,CDart*,int,int);
extern int    getNewDirectInfo(SGMapVertex*);
extern void   freeDirectInfo(SGMapVertex*,int);
extern void   setDirectInfo(SGMapVertex*,CDart*,int,void*);
extern void*  getDirectInfo(SGMapVertex*,CDart*,int);
extern int    get_vertex_coord(SGMapVertex*,CDart*,float*,float*,float*);
extern void   set_vertex_coord(SGMapVertex*,CDart*,double,double,double);
extern int    checkGmap(SGMapVertex*);
extern int    compareNcells(SGMapVertex*,CDart*,CDart*,int);


extern CCoverage* getAllCoverage(SGMapVertex*);
extern CCoverage* getNcellCoverage(SGMapVertex*,CDart*,int);
extern void       deleteCoverage(CCoverage*);
extern void       reinitCoverage(CCoverage*);
extern CDart*     getCurrentDart(CCoverage*);
extern int        cont(CCoverage*);
extern void       next(CCoverage*);

extern int loadMoka(SGMapVertex*,const char*,CDart***);
extern int saveMoka(SGMapVertex*,const char*);

extern CDart* new_ncell(SGMapVertex*,int);
extern CDart* new_ncell_polygon(SGMapVertex*,int);
extern CDart* new_ncell_square(SGMapVertex*,int,int,int);
extern void   new_ncell_sphere(SGMapVertex*,int,int,CDart**,CDart**);
extern CDart* new_ncell_polyline(SGMapVertex*,int);

extern void   glue2FacesBy4Verteces(SGMapVertex*,CDart*,CDart*,CDart*,CDart*,CDart*,CDart*);
extern CDart* insert_vertex(SGMapVertex*,CDart*,CDart**,CDart**);
extern CDart* insert_edge(SGMapVertex*,CDart*,CDart*,CDart**,CDart**);
extern CDart* insert_face(SGMapVertex*,CDart*,CDart**,int,CDart**,CDart**);
extern CDart* create_edge(SGMapVertex*,CDart*,CDart*);
extern CDart* create_face(SGMapVertex*,CDart***,int);
extern CDart* create_volume(SGMapVertex*,CDart**,int,CDart***,int*,int);
extern CDart* basic_remove(SGMapVertex*,CDart*,int);
extern int    basic_delete(SGMapVertex*,CDart*,int,CDart***);
