(*=======================================================-*-tuareg-*-======
 *
 * MGS : a general model of systems
 *
 *    Olivier Michel      : michel@lami.univ-evry.fr
 *    Jean-Louis Giavitto : giavitto@lami.univ-evry.fr
 *    Antoine Spicher     : aspicher@lami.univ-evry.fr
 *    Julien Cohen        : jcohen@lami.univ-evry.fr
 *    Mailing-list        : mgs@lami.univ-evry.fr
 *    WWW                 : http://mgs.lami.univ-evry.fr
 *
 * LaMI umr 8042 du CNRS, Genopole (C), Universite d'Evry Val d'Essonne
 *
 *
 * -------------------------------------------------------------------
 * File: $RCSfile: def_rec.ml,v $
 * Symbolic name : $Name:  $
 * Author: OM, JLG
 * Modified: $Date: 2004-08-16 20:52:45 $
 * Version: $Revision: 1.2 $
 * -------------------------------------------------------------------
 *
 * Status:  
 *     La representation d'un record: reprsentation par map.
 *     Code  partir du module map de la librairie CAML, augment de plusieurs 
 *     fonctions.
 *
 *     Un record MGS est un dictionnaire qui associe une valeur MGS  une cl.
 *     La cl est n'importe quelle valeur MGS, mme si une syntaxe spciale
 *     est reserve au cls qui sont des symboles.
 *     L'acces se fait par:  r.(key)  dans la syntaxe MGS et 
 *        r.(`key) == r.key  
 *     on retouve donc l'acces par "nom du champ" des records habituels.
 *
 *     La topologie d'un record est celle d'un graphe sans artes: 
 *     tous les sommets sont isols, sans voisins. La position est la cl.
 *
 *=========================================================================
 *)


Global.__register_version "$RCSfile: def_rec.ml,v $" "$Revision: 1.2 $" "$Date: 2004-08-16 20:52:45 $";;


type ('key, 'a) trec =
  | Empty_map
  | Node_map of ('key, 'a) trec * 'key * 'a * ('key, 'a) trec * int
;;


