(*=======================================================-*-tuareg-*-======
 *
 * MGS : a general model of systems
 *
 *    Olivier Michel      : michel@lami.univ-evry.fr
 *    Jean-Louis Giavitto : giavitto@lami.univ-evry.fr
 *    Antoine Spicher     : aspicher@lami.univ-evry.fr
 *    Julien Cohen        : jcohen@lami.univ-evry.fr
 *    Mailing-list        : mgs@lami.univ-evry.fr
 *    WWW                 : http://mgs.lami.univ-evry.fr
 *
 * LaMI umr 8042 du CNRS, Genopole (C), Universite d'Evry Val d'Essonne
 *
 *
 * -------------------------------------------------------------------
 * File: $RCSfile: type_seq.ml,v $
 * Symbolic name : $Name:  $
 * Author: OM, JLG
 * Modified: $Date: 2005-09-30 12:36:25 $
 * Version: $Revision: 1.4 $
 * -------------------------------------------------------------------
 *
 * Voir le fichier Common/type.ml
 * 
 *=========================================================================
 *)



open Global;;
open Valeur;;
open Type;;

__register_version "$RCSfile: type_seq.ml,v $" "$Revision: 1.4 $" "$Date: 2005-09-30 12:36:25 $";;





(*!*)(** 
       @module collections
       @name 'seq
       @type any_bool
       Seq type and predicate.
       @voir 'set      'set
       @voir 'bag      'bag
       @voir 'monoidal 'monoidal
*)(*!*)

let seq_desc = create_type
		 { name = "'seq";
		   concrete = true;
		   leibniz = false;
		   predicate = wrap_pred(is_leibniz);
		   empty = VAL_undef "dummy for empty field in type descriptor 'seq";
		   pospredicate = pospredicate_int;
		   make = make_dummy;
		   xxxify = xxxify_dummy "'seq";
		   derive_from = [monoidal_desc];
		   father_of = [];
		   uid = get_new_uid();
		 }
;;

seq_desc.predicate <- wrap_pred(coll_pred seq_desc);;

(** !!! Attention !!!
 *** Ne pas oublier de mettre  jour les champs
 ***     _ make 
 ***     _ xxxify
 ***     _ empty
 *** du descripteur de type dans le fichier seq.ml
 ***)


(** On cre un type special de sequence drivant dircement de leibniz
 ** pour bien faire la distinction d'avec les cellules.
 ** L'ide est d'empecher toute cration d'lment de ce type  moins de passer
 ** par la syntaxe adequate (`v:[d=...])
 **)

let pRhsSpec_desc = create_type
		      { name = "'pRhsSpec";
			concrete = true;
			leibniz = false;
			predicate = wrap_pred(is_leibniz);
			empty = VAL_undef "dummy for empty field in type descriptor 'pRhsSpec";
			pospredicate = pospredicate_int;
			make = make_dummy;
			xxxify = xxxify_dummy "'pRhsSpec";
			derive_from = [leibniz_desc];
			father_of = [];
			uid = get_new_uid();
		      }
;;

pRhsSpec_desc.predicate <- wrap_pred(coll_pred pRhsSpec_desc);;
pRhsSpec_desc.empty <- VAL_seq([||], pRhsSpec_desc) ;;
