(*=======================================================-*-tuareg-*-======
 *
 * MGS : a general model of systems
 *
 *    Olivier Michel      : michel@lami.univ-evry.fr
 *    Jean-Louis Giavitto : giavitto@lami.univ-evry.fr
 *    Antoine Spicher     : aspicher@lami.univ-evry.fr
 *    Julien Cohen        : jcohen@lami.univ-evry.fr
 *    Mailing-list        : mgs@lami.univ-evry.fr
 *    WWW                 : http://mgs.lami.univ-evry.fr
 *
 * LaMI umr 8042 du CNRS, Genopole (C), Universite d'Evry Val d'Essonne
 *
 *
 * -------------------------------------------------------------------
 * File: $RCSfile: kernel_set.ml,v $
 * Symbolic name : $Name:  $
 * Author: OM, JLG
 * Modified: $Date: 2004-10-08 13:55:12 $
 * Version: $Revision: 1.2 $
 * -------------------------------------------------------------------
 *
 * Status: 
 *   voir aussi Common/kernel_collection.ml
 *   qui contient les fcts gnriques sur les collections et les monoidaux.
 *
 *=========================================================================
 *)

open Global;;
open Valeur;;
open Type;;
open Dispatch_sig;;
open Dispatch;;
open Environnement;;
open Mset;;


__register_version "$RCSfile: kernel_set.ml,v $" "$Revision: 1.2 $" "$Date: 2004-10-08 13:55:12 $";;


print_string "(* loading kernel functions on SET into user-space ... ";
flush Pervasives.stdout;;



(**
  @module collections
  @name 'setify
  @type collection_set
  @type scalar_set

  Transform its argument into a set.
  ['setify(c)] collects allthe elements of the collection
  [c] into a set. If [c] is already a set, [setify] is the identity.
  
  ['setify(s)] where [s] is a scalar returns
  the set with [s] as the unique element.
*)
addenv_impure "'setify"  (fun_1 __setify );;



(* --- fin de l'installation des fonctions de base --- *)

print_string "done *)";
print_newline();;

(* ======================================================= *)
