(*=======================================================-*-tuareg-*-======
 *
 * MGS : a general model of systems
 *
 *    Olivier Michel      : michel@lami.univ-evry.fr
 *    Jean-Louis Giavitto : giavitto@lami.univ-evry.fr
 *    Julien Cohen        : jcohen@lami.univ-evry.fr
 *    Mailing-list        : mgs@lami.univ-evry.fr
 *    WWW                 : http://mgs.lami.univ-evry.fr
 *
 * LaMI umr 8042 du CNRS, Genopole (C), Universite d'Evry Val d'Essonne
 *
 *
 * -------------------------------------------------------------------
 * File: $RCSfile: topo_set.ml,v $
 * Symbolic name : $Name:  $
 * Author: OM, JLG
 * Modified: $Date: 2005-07-12 15:14:17 $
 * Version: $Revision: 1.3 $
 * -------------------------------------------------------------------
 *
 * Status: voir le commentaire general dans topology.ml
 *          
 * Ici on developpe les instance de generic_topo qui correspondent 
 * aux collections Associatives/Commutative (et parfois idempotente)
 *
 *=========================================================================
 *)

open Global;;
open Global;;
open Topo_ac;;
open Valeur;;
open Printer;;

__register_version "$RCSfile: topo_set.ml,v $" "$Revision: 1.3 $" "$Date: 2005-07-12 15:14:17 $";;

exception FoundIntPos of int;;


class topo_set (c, couleur) valeur card =
object (self)
  inherit [set_collection] topo_ac (c, couleur, valeur) card

  method iterateur = Core_set.iter
  method empty     = Core_set.empty
  method add v c   = (match v with VAL_undef _ -> c | _ -> Core_set.add v c)
  method union     = Core_set.union
  method from_coll = (function VAL_set (v, _) -> v
			|      x              -> raise (Erreur ("set awaited, received : "^(to_string(prsvalue x)))))
  method to_coll x = VAL_set x


  method dispose_get_NvalueS_from_pos = true

  method get_NposS_from_pos position nombre valeur =
    if (nombre <> 1)
    then None
    else (
      if ((self#usable(position))&&(Dispatch_sig.equal_mgs_value valeur (self#get_value_from_pos position)))
      then Some ([position],position)
      else None
    )
    
end;;

