(*=======================================================-*-tuareg-*-======
 *
 * MGS : a general model of systems
 *
 *    Olivier Michel      : michel@lami.univ-evry.fr
 *    Jean-Louis Giavitto : giavitto@lami.univ-evry.fr
 *    Antoine Spicher     : aspicher@lami.univ-evry.fr
 *    Julien Cohen        : jcohen@lami.univ-evry.fr
 *    Mailing-list        : mgs@lami.univ-evry.fr
 *    WWW                 : http://mgs.lami.univ-evry.fr
 *
 * LaMI umr 8042 du CNRS, Genopole (C), Universite d'Evry Val d'Essonne
 *
 *
 * -------------------------------------------------------------------
 * File: $RCSfile: type_set.ml,v $
 * Symbolic name : $Name:  $
 * Author: OM, JLG
 * Modified: $Date: 2004-10-08 13:55:12 $
 * Version: $Revision: 1.2 $
 * -------------------------------------------------------------------
 *
 * Voir le fichier Common/type.ml
 * 
 *=========================================================================
 *)



open Global;;
open Valeur;;
open Type;;

__register_version "$RCSfile: type_set.ml,v $" "$Revision: 1.2 $" "$Date: 2004-10-08 13:55:12 $";;


(*!*)(** 
       @module collections
       @name 'set
       @type any_bool
       Set type and predicate.
       @voir 'set      'set
       @voir 'bag      'seq
       @voir 'monoidal 'monoidal
*)(*!*)

let set_desc = create_type
		 { name = "'set";
		   concrete = true;
		   leibniz = false;
		   predicate = wrap_pred(is_leibniz);
		   pospredicate = pospredicate_int;
		   make = make_dummy;
		   xxxify = xxxify_dummy "'set";
		   empty = VAL_undef "dummy for empty field in type descriptor 'set";
		   derive_from = [monoidal_desc];
		   father_of = [];
		   uid = get_new_uid();
		 }
;;

set_desc.predicate <- wrap_pred(coll_pred set_desc);;


(** !!! Attention !!!
 *** Ne pas oublier de mettre  jour les champs
 ***     _ make 
 ***     _ xxxify
 ***     _ empty
 *** du descripteur de type dans le fichier bag.ml
 ***)
