/*
 * lib-gmapkernel : Un noyau de 3-G-cartes et des oprations.
 * Copyright (C) Moka Team, moka@sic.univ-poitiers.fr
 *               http://www.sic.univ-poitiers.fr/moka/
 *
 * This file is part of lib-gmapkernel
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

//******************************************************************************
#include "g-map-generic.hh"
using namespace GMap3d;
//******************************************************************************
void CGMapGeneric::shiftOneFictiveEdge(CDart* ADart, CDart* ADart2)
{
  CDart * d1 = alpha1(ADart);
  CDart * d2 = alpha21(ADart);
  CDart * d3 = alpha1(ADart2);

  unsew1(d1);       // rappel : unsew1 1-decoud en meme temps alpha3(d1)
  if (!isFree1(d2))
    unsew1(d2);

  unsew1(ADart2);

  sew1(d1,d2);

  sew1(ADart,ADart2);
  sew1(alpha2(ADart),d3);
}
//******************************************************************************
void CGMapGeneric::shiftAllAdjacentFictiveEdges(CDart* ADart, int AMark)
{
  CDart * d = alpha12(ADart);
  CDart * tmp;

  while (isMarked(d,AMark))  // Tant qu'on est sur une arte fictive
    {
      tmp = alpha12(d);
      shiftOneFictiveEdge(d,alpha0(ADart));
      d=tmp;
    }
}
//******************************************************************************
void CGMapGeneric::shiftAllFictiveEdges(CDart* ADart, int AMark)
{
  shiftAllAdjacentFictiveEdges(ADart, AMark);

  shiftAllAdjacentFictiveEdges(alpha2(ADart), AMark);
}
//******************************************************************************
bool CGMapGeneric::existFictiveEdgeIncidentTo(CDart *ADart, int AMark)
{
  CDynamicCoverage123 it(this,ADart);
  while(it.cont())
    {
      if (isMarked(*it,AMark)) return true;
      ++it;
    }
  return false;
}
//******************************************************************************
