/*
 * lib-gmapkernel : Un noyau de 3-G-cartes et des oprations.
 * Copyright (C) Moka Team, moka@sic.univ-poitiers.fr
 *               http://www.sic.univ-poitiers.fr/moka/
 *
 * This file is part of lib-gmapkernel
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

//******************************************************************************
// Ce fichier fait partie de "g-map-generic.hh".
//******************************************************************************

public:

/**
 * paissit les brins marqus avec la marque AMarkNumber.
 * Chaque brin marqu est dupliqu deux fois et ses champs
 * directInfo[ADirectInfoIndex1] et directInfo[ADirectInfoIndex2] pointent
 * vers les brins dupliqus (ceci afin que les classes descendant de
 * CGMapGeneric puissent effectuer la mise  jour des plongements).
 *
 * Remarque:  l'issue de la mthode, pour chaque brin B marqu avec la
 * marque AMarkNumber on alpha aussi:
 *
 * B->getDirectInfo(ADirectInfoIndex1)
 *  ->getDirectInfo(ADirectInfoIndex1) = B
 *
 * B->getDirectInfo(ADirectInfoIndex1)
 *  ->getDirectInfo(ADirectInfoIndex2) = NULL
 *
 * B->getDirectInfo(ADirectInfoIndex2)
 *  ->getDirectInfo(ADirectInfoIndex1) = NULL
 *
 * B->getDirectInfo(ADirectInfoIndex2)
 *  ->getDirectInfo(ADirectInfoIndex2) = B
 *
 * @param AMarkNumber Un numro de marque
 * @param ADirectInfoIndex1 Un premier indice de champ directInfo 
 *                           utiliser
 * @param ADirectInfoIndex2 Un second indice de champ directInfo  utiliser
 * @return Le nombre de brins paissis
 *
 * @postcondition Si i est une dimension (0, 1, 2 ou 3), si b est un brin
 *   i-cousu et si b et alpha(b,i) sont marqus, on alpha:
 *   alpha(b->getDirectInfo(ADirectInfoIndex1), i) =
 *     alpha(b, i)->getDirectInfo(ADirectInfoIndex2)
 */
virtual int thickenMarkedDarts(int AMarkNumber,
			       int ADirectInfoIndex1,
			       int ADirectInfoIndex2);

//******************************************************************************
