/*
 * lib-gmapkernel : Un noyau de 3-G-cartes et des oprations.
 * Copyright (C) Moka Team, moka@sic.univ-poitiers.fr
 *               http://www.sic.univ-poitiers.fr/moka/
 *
 * This file is part of lib-gmapkernel
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

//******************************************************************************
// Ce fichier fait partie de "g-map-vertex.hh".
//******************************************************************************

public:

/// Met  jour le plongement clat de tous les brins de la carte.
void updateAllBurstDarts();

/**
 * Met  jour le plongement clat des brins marqus avec la marque
 * AMarkNumber.
 * Si AUpdateIncidentVolumes vaut 'vrai', c'est le plongement clat de tous
 * les brins des volumes incidents  un sommet dont un brin au moins est
 * marqu avec la marque AMarkNumber qui est mis  jour.
 *
 * @param AMarkNumber Un numro de marque
 * @param AUpdateIncidentVolumes Un boolen
 */
void updateMarkedBurstDarts(int AMarkNumber,
			    bool AUpdateIncidentVolumes = true);

//******************************************************************************
