/*
 * lib-gmapkernel : Un noyau de 3-G-cartes et des oprations.
 * Copyright (C) Moka Team, moka@sic.univ-poitiers.fr
 *               http://www.sic.univ-poitiers.fr/moka/
 *
 * This file is part of lib-gmapkernel
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

//******************************************************************************
// Ce fichier fait partie de "g-map-vertex.hh".
//******************************************************************************

public:

/**
 * Prolonge une polyligne (en rajoutant une arte  son bout).
 * Si ADart vaut NULL, cre un premier brin d'une nouvelle polyligne.
 *
 * @param ADart Un brin constituant le bout d'une polyligne
 * @param AVertex Le plongement du sommet  rajouter au bout de la polyligne
 */
CDart* prolongPolyline(CDart* ADart, const CVertex & AVertex);

/**
 * Teste si une face est plane.
 *
 * @param ADart Un brin quelconque de la carte
 * @return 'vrai' si tous les sommets de la face sont situs sur un mme plan
 */
bool isPlanarPolyline(CDart* ADart);

/**
 * Marque toutes les faces non planaires de la carte.
 *
 * @param AMarkNumber Un numro de marque
 * @return 'vrai' si une face non plane au moins alpha t trouve
 */
bool markNonPlanarPolylines(int AMarkNumber);

//******************************************************************************
