module Copy = 
struct

  module P(Gf : Sig.G)
    (Gt : Sig.P)
    (M : sig
       val vertex : Gt.t -> Gf.V.t -> (Gt.V.t * Gt.t)
       val edge : Gt.t -> Gt.V.t -> Gt.V.t -> Gt.t
     end) =
  struct
    
    module HO = Hashtbl.Make(Gf.V)
      
    let copy g =
      let vertices = HO.create 97 in
      let g' = 
	Gf.fold_vertex 
	  (fun x g' ->
	     let v', g' = M.vertex g' x in
	       HO.add vertices x v';
	       g')
	  g Gt.empty
      in
      let g' =
	Gf.fold_edges 
	  (fun x y g' ->
	     M.edge g' (HO.find vertices x) (HO.find vertices y))
	  g g'
      in g'
  end

  module I(Gf : Sig.G)
    (Gt : Sig.I)
    (M : sig
       val vertex : Gt.t -> Gf.V.t -> Gt.V.t
       val edge : Gt.t -> Gt.V.t -> Gt.V.t -> unit
     end) =
  struct
    
    module HO = Hashtbl.Make(Gf.V)
      
    let copy g =
      let vertices = HO.create 97 in
      let g' = Gt.create () in
	Gf.iter_vertex 
	  (fun x ->
	     let v' = M.vertex g' x in
	       HO.add vertices x v')	  
	  g;
	Gf.iter_edges 
	  (fun x y ->
	     M.edge g' (HO.find vertices x) (HO.find vertices y))
	  g;
	g'	  
  end
    
end
