(**
  Minimal separators of a graph
  
  Based on the article:
  Generating all the minimal separators of a graph.
  by A. Berry, J.-P. Bordat and O.Cogis
  http://www.isima.fr/berry/generating.html

  @author Matthieu Sozeau
  @author Pierre-Loic Garoche
*)

module MinimalSeparators :
sig
  module P :
    functor (G : Sig.P) ->
  sig
    module VertexSet : Set.S with type elt = G.V.t

    (** [allminsep g] computes the list of all minimal separators of g *)
    val allminsep : G.t -> VertexSet.t list
  end
  
  module I :
    functor (G : Sig.I) ->
  sig
    module VertexSet : Set.S with type elt = G.V.t
			       
    (** [allminsep g] computes the list of all minimal separators of g *)
    val allminsep : G.t -> VertexSet.t list
  end
end
